import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Yeah, this code is REALLY messy
 */
public class ScrollingFrame  extends Actor
{
    static final Color ground_color = Color.BLACK;
    static final Color bounce_color = Color.YELLOW;
    static final Color hurt_color = Color.RED;
    static final Color warp_color = Color.CYAN;
    
    int x_offset = 0;
    int y_offset = -50;

    private GreenfootImage scrollingImage;
    private GreenfootImage bgImage = new GreenfootImage("WarpZoneFrame.png");
    
    //////////////COMMANDS//////////////
    //////////////COMMANDS//////////////

    public boolean isGround(double x, double y)
    {
        try
        {
            x = x-x_offset;
            y = y-y_offset;
            
            if(getImage().getColorAt((int)x, (int)y).equals(ground_color))
                return true;

            return false;
        }
        catch(IndexOutOfBoundsException ex)
        {
            return false;
        }
    }
    
    public boolean isWarp(double x, double y)
    {
        try
        {
            x = x-x_offset;
            y = y-y_offset;
            
            if(getImage().getColorAt((int)x, (int)y).equals(warp_color))
                return true;

            return false;
        }
        catch(IndexOutOfBoundsException ex)
        {
            return false;
        }
    }

    public boolean isBounce(double x, double y)
    {
        try
        {
            x = x-x_offset;
            y = y-y_offset;
            
            if(getImage().getColorAt((int)x, (int)y).equals(bounce_color))
                return true;

            return false;
        }
        catch(IndexOutOfBoundsException ex)
        {
            return false;
        }
    }

    public boolean isHurt(double x, double y)
    {
        try
        {
            x = x-x_offset;
            y = y-y_offset;
            
            if(getImage().getColorAt((int)x, (int)y).equals(hurt_color))
                return true;

            return false;
        }
        catch(IndexOutOfBoundsException ex)
        {
            return false;
        }
    }
    
    protected void addedToWorld(World world)
    {
        GreenfootImage background = new GreenfootImage(bgImage.getWidth(), getWorld().getHeight()+50);
        scrollingImage = getScrollingImage(bgImage.getWidth(), getWorld().getHeight()+50);
        background.drawImage(scrollingImage, 0, 0);
        setImage(background);
    }

    ///////////START////////////
    ///////////START////////////

    public void act() 
    {
        paint(((myWorld) getWorld()).scroll_position);
    }

    /**
     * Paint scrolling image at given position and make sure the rest of
     * the background is also painted with the same image.
     */
    private void paint(int position)
    {
        GreenfootImage bg = getImage();
        bg.drawImage(scrollingImage, position, 0);
        bg.drawImage(scrollingImage, position - scrollingImage.getWidth(), 0);
    }

    /**
     * Returns an image with the given dimensions.
     */
    private GreenfootImage getScrollingImage(int width, int height)
    {
        GreenfootImage image = new GreenfootImage(width, height);
        for(int x = 0; x < width; x += bgImage.getWidth()) {
            for(int y = 0; y < height; y += bgImage.getHeight()) {
                image.drawImage(bgImage, x, y);
            }
        }
        return image;
    } 
}

